// src/backend/dynamic_process.cc - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#include "dynamic_process.hh"
#include "static_process.hh"

using namespace sgpem;
using std::vector;

DynamicProcess::DynamicProcess(StaticProcess& core) :
  DynamicSchedulable(core)
{
}
  
DynamicProcess::DynamicProcess(const DynamicProcess &other) :
  Schedulable(), DynamicSchedulable(other), Process()
{
  typedef vector<DynamicThread*>::iterator ThreadIt;
  
  const vector<DynamicThread*>& other_threads = other._dynamic_threads;

// FIXME uncomment when DynamicThread is complete  
//  for(ThreadIt it = other_threads.begin(); it != other_threads.end(); ++it)
//    _dynamic_threads.push_back(new DynamicThread(*(*it)));
}

std::vector<Thread*> DynamicProcess::get_threads()
{
  //FIXME uncomment when DynamicThread is complete  
  //return vector<Thread*>(_dynamic_threads.begin(), _dynamic_threads.end());
  return vector<Thread*>();
}
  
//FIXME already implemented in DynamicSchedulable
//state get_state() const
//{
//  //TODO complicated code here! leave me some time to figure
//  // out what I need to do inside this method
//}

std::vector<DynamicThread*> DynamicProcess::get_dynamic_threads()
{
  return _dynamic_threads;
}

void DynamicProcess::serialize(SerializeVisitor& translator)
{
  //FIXME write this code. I'm predictable, I know
}
    
